Index: uspace/lib/ui/src/menuentry.c
===================================================================
--- uspace/lib/ui/src/menuentry.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/src/menuentry.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,534 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Menu entry
+ */
+
+#include <adt/list.h>
+#include <errno.h>
+#include <gfx/color.h>
+#include <gfx/context.h>
+#include <gfx/render.h>
+#include <gfx/text.h>
+#include <io/pos_event.h>
+#include <stdlib.h>
+#include <str.h>
+#include <ui/control.h>
+#include <ui/paint.h>
+#include <ui/menuentry.h>
+#include <ui/window.h>
+#include "../private/menubar.h"
+#include "../private/menuentry.h"
+#include "../private/menu.h"
+#include "../private/resource.h"
+
+enum {
+	menu_entry_hpad = 4,
+	menu_entry_vpad = 4,
+	menu_entry_column_pad = 8,
+	menu_entry_sep_height = 2,
+	menu_entry_hpad_text = 1,
+	menu_entry_vpad_text = 0,
+	menu_entry_column_pad_text = 2,
+	menu_entry_sep_height_text = 1
+};
+
+/** Create new menu entry.
+ *
+ * @param menu Menu
+ * @param caption Caption
+ * @param shortcut Shotcut key(s) or empty string
+ * @param rmentry Place to store pointer to new menu entry
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ui_menu_entry_create(ui_menu_t *menu, const char *caption,
+    const char *shortcut, ui_menu_entry_t **rmentry)
+{
+	ui_menu_entry_t *mentry;
+	gfx_coord_t caption_w;
+	gfx_coord_t shortcut_w;
+
+	mentry = calloc(1, sizeof(ui_menu_entry_t));
+	if (mentry == NULL)
+		return ENOMEM;
+
+	mentry->caption = str_dup(caption);
+	if (mentry->caption == NULL) {
+		free(mentry);
+		return ENOMEM;
+	}
+
+	mentry->shortcut = str_dup(shortcut);
+	if (mentry->caption == NULL) {
+		free(mentry->caption);
+		free(mentry);
+		return ENOMEM;
+	}
+
+	mentry->menu = menu;
+	list_append(&mentry->lentries, &menu->entries);
+
+	/* Update accumulated menu entry dimensions */
+	ui_menu_entry_column_widths(mentry, &caption_w, &shortcut_w);
+	if (caption_w > menu->max_caption_w)
+		menu->max_caption_w = caption_w;
+	if (shortcut_w > menu->max_shortcut_w)
+		menu->max_shortcut_w = shortcut_w;
+	menu->total_h += ui_menu_entry_height(mentry);
+
+	*rmentry = mentry;
+	return EOK;
+}
+
+/** Create new separator menu entry.
+ *
+ * @param menu Menu
+ * @param rmentry Place to store pointer to new menu entry
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ui_menu_entry_sep_create(ui_menu_t *menu, ui_menu_entry_t **rmentry)
+{
+	ui_menu_entry_t *mentry;
+	errno_t rc;
+
+	rc = ui_menu_entry_create(menu, "", "", &mentry);
+	if (rc != EOK)
+		return rc;
+
+	/* Need to adjust menu height when changing to separator */
+	menu->total_h -= ui_menu_entry_height(mentry);
+	mentry->separator = true;
+	menu->total_h += ui_menu_entry_height(mentry);
+
+	*rmentry = mentry;
+	return EOK;
+}
+
+/** Destroy menu entry.
+ *
+ * @param mentry Menu entry or @c NULL
+ */
+void ui_menu_entry_destroy(ui_menu_entry_t *mentry)
+{
+	if (mentry == NULL)
+		return;
+
+	list_remove(&mentry->lentries);
+	free(mentry->caption);
+	free(mentry);
+}
+
+/** Set menu entry callback.
+ *
+ * @param mentry Menu entry
+ * @param cb Menu entry callback
+ * @param arg Callback argument
+ */
+void ui_menu_entry_set_cb(ui_menu_entry_t *mentry, ui_menu_entry_cb_t cb,
+    void *arg)
+{
+	mentry->cb = cb;
+	mentry->arg = arg;
+}
+
+/** Get first menu entry in menu.
+ *
+ * @param menu Menu
+ * @return First menu entry or @c NULL if there is none
+ */
+ui_menu_entry_t *ui_menu_entry_first(ui_menu_t *menu)
+{
+	link_t *link;
+
+	link = list_first(&menu->entries);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ui_menu_entry_t, lentries);
+}
+
+/** Get next menu entry in menu.
+ *
+ * @param cur Current menu entry
+ * @return Next menu entry or @c NULL if @a cur is the last one
+ */
+ui_menu_entry_t *ui_menu_entry_next(ui_menu_entry_t *cur)
+{
+	link_t *link;
+
+	link = list_next(&cur->lentries, &cur->menu->entries);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ui_menu_entry_t, lentries);
+}
+
+/** Get width of menu entry.
+ *
+ * @param mentry Menu entry
+ * @param caption_w Place to store caption width
+ * @param shortcut_w Place to store shortcut width
+ */
+void ui_menu_entry_column_widths(ui_menu_entry_t *mentry,
+    gfx_coord_t *caption_w, gfx_coord_t *shortcut_w)
+{
+	ui_resource_t *res;
+
+	/*
+	 * This needs to work even if the menu is not open, so we cannot
+	 * use the menu's resource, which is only created after the menu
+	 * is open (and its window is created). Use the menu bar's
+	 * resource instead.
+	 */
+	res = ui_window_get_res(mentry->menu->mbar->window);
+
+	*caption_w = gfx_text_width(res->font, mentry->caption);
+	*shortcut_w = gfx_text_width(res->font, mentry->shortcut);
+}
+
+/** Compute width of menu entry.
+ *
+ * @param menu Menu
+ * @param caption_w Widht of caption text
+ * @param shortcut_w Width of shortcut text
+ * @return Width in pixels
+ */
+gfx_coord_t ui_menu_entry_calc_width(ui_menu_t *menu, gfx_coord_t caption_w,
+    gfx_coord_t shortcut_w)
+{
+	ui_resource_t *res;
+	gfx_coord_t hpad;
+	gfx_coord_t width;
+
+	/*
+	 * This needs to work even if the menu is not open, so we cannot
+	 * use the menu's resource, which is only created after the menu
+	 * is open (and its window is created). Use the menu bar's
+	 * resource instead.
+	 */
+	res = ui_window_get_res(menu->mbar->window);
+
+	if (res->textmode)
+		hpad = menu_entry_hpad_text;
+	else
+		hpad = menu_entry_hpad;
+
+	width = caption_w + 2 * hpad;
+
+	if (shortcut_w != 0) {
+		if (res->textmode)
+			width += menu_entry_column_pad_text;
+		else
+			width += menu_entry_column_pad;
+
+		width += shortcut_w;
+	}
+
+	return width;
+}
+
+/** Get height of menu entry.
+ *
+ * @param mentry Menu entry
+ * @return Width in pixels
+ */
+gfx_coord_t ui_menu_entry_height(ui_menu_entry_t *mentry)
+{
+	ui_resource_t *res;
+	gfx_font_metrics_t metrics;
+	gfx_coord_t height;
+	gfx_coord_t vpad;
+
+	/*
+	 * This needs to work even if the menu is not open, so we cannot
+	 * use the menu's resource, which is only created after the menu
+	 * is open (and its window is created). Use the menu bar's
+	 * resource instead.
+	 */
+	res = ui_window_get_res(mentry->menu->mbar->window);
+
+	if (res->textmode) {
+		vpad = menu_entry_vpad_text;
+	} else {
+		vpad = menu_entry_vpad;
+	}
+
+	if (mentry->separator) {
+		/* Separator menu entry */
+		if (res->textmode)
+			height = menu_entry_sep_height_text;
+		else
+			height = menu_entry_sep_height;
+	} else {
+		/* Normal menu entry */
+		gfx_font_get_metrics(res->font, &metrics);
+		height = metrics.ascent + metrics.descent + 1;
+	}
+
+	return height + 2 * vpad;
+}
+
+/** Paint menu entry.
+ *
+ * @param mentry Menu entry
+ * @param pos Position where to paint entry
+ * @return EOK on success or an error code
+ */
+errno_t ui_menu_entry_paint(ui_menu_entry_t *mentry, gfx_coord2_t *pos)
+{
+	ui_resource_t *res;
+	gfx_text_fmt_t fmt;
+	gfx_color_t *bg_color;
+	ui_menu_entry_geom_t geom;
+	gfx_rect_t rect;
+	errno_t rc;
+
+	res = ui_menu_get_res(mentry->menu);
+
+	ui_menu_entry_get_geom(mentry, pos, &geom);
+
+	gfx_text_fmt_init(&fmt);
+	fmt.halign = gfx_halign_left;
+	fmt.valign = gfx_valign_top;
+
+	if ((mentry->held && mentry->inside) ||
+	    mentry == mentry->menu->selected) {
+		fmt.color = res->wnd_sel_text_color;
+		bg_color = res->wnd_sel_text_bg_color;
+	} else {
+		fmt.color = res->wnd_text_color;
+		bg_color = res->wnd_face_color;
+	}
+
+	rc = gfx_set_color(res->gc, bg_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_fill_rect(res->gc, &geom.outer_rect);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_puttext(res->font, &geom.caption_pos, &fmt, mentry->caption);
+	if (rc != EOK)
+		goto error;
+
+	fmt.halign = gfx_halign_right;
+
+	rc = gfx_puttext(res->font, &geom.shortcut_pos, &fmt, mentry->shortcut);
+	if (rc != EOK)
+		goto error;
+
+	if (mentry->separator) {
+		rect.p0 = geom.caption_pos;
+		rect.p1.x = geom.shortcut_pos.x;
+		rect.p1.y = rect.p0.y + 2;
+		rc = ui_paint_bevel(res->gc, &rect, res->wnd_shadow_color,
+		    res->wnd_highlight_color, 1, NULL);
+		if (rc != EOK)
+			goto error;
+	}
+
+	rc = gfx_update(res->gc);
+	if (rc != EOK)
+		goto error;
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Handle button press in menu entry.
+ *
+ * @param mentry Menu entry
+ * @param pos Menu entry position
+ */
+void ui_menu_entry_press(ui_menu_entry_t *mentry, gfx_coord2_t *pos)
+{
+	if (mentry->held)
+		return;
+
+	if (mentry->separator)
+		return;
+
+	mentry->inside = true;
+	mentry->held = true;
+	ui_menu_entry_paint(mentry, pos);
+}
+
+/** Handle button release in menu entry.
+ *
+ * @param mentry Menu entry
+ */
+void ui_menu_entry_release(ui_menu_entry_t *mentry)
+{
+	if (!mentry->held)
+		return;
+
+	mentry->held = false;
+
+	if (mentry->inside) {
+		/* Close menu */
+		ui_menu_bar_select(mentry->menu->mbar, NULL, NULL);
+
+		/* Call back */
+		ui_menu_entry_cb(mentry);
+	}
+}
+
+/** Call menu entry callback.
+ *
+ * @param mentry Menu entry
+ */
+void ui_menu_entry_cb(ui_menu_entry_t *mentry)
+{
+	if (mentry->cb != NULL)
+		mentry->cb(mentry, mentry->arg);
+}
+
+/** Pointer entered menu entry.
+ *
+ * @param mentry Menu entry
+ * @param pos Menu entry position
+ */
+void ui_menu_entry_enter(ui_menu_entry_t *mentry, gfx_coord2_t *pos)
+{
+	if (mentry->inside)
+		return;
+
+	mentry->inside = true;
+	if (mentry->held)
+		(void) ui_menu_entry_paint(mentry, pos);
+}
+
+/** Pointer left menu entry.
+ *
+ * @param mentry Menu entry
+ * @param pos Menu entry position
+ */
+void ui_menu_entry_leave(ui_menu_entry_t *mentry, gfx_coord2_t *pos)
+{
+	if (!mentry->inside)
+		return;
+
+	mentry->inside = false;
+	if (mentry->held)
+		(void) ui_menu_entry_paint(mentry, pos);
+}
+
+/** Handle menu entry position event.
+ *
+ * @param mentry Menu entry
+ * @param pos Menu entry position (top-left corner)
+ * @param pos_event Position event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t ui_menu_entry_pos_event(ui_menu_entry_t *mentry,
+    gfx_coord2_t *pos, pos_event_t *event)
+{
+	ui_menu_entry_geom_t geom;
+	gfx_coord2_t ppos;
+	bool inside;
+
+	ppos.x = event->hpos;
+	ppos.y = event->vpos;
+
+	ui_menu_entry_get_geom(mentry, pos, &geom);
+	inside = gfx_pix_inside_rect(&ppos, &geom.outer_rect);
+
+	switch (event->type) {
+	case POS_PRESS:
+		if (inside) {
+			ui_menu_entry_press(mentry, pos);
+			return ui_claimed;
+		}
+		break;
+	case POS_RELEASE:
+		if (mentry->held) {
+			ui_menu_entry_release(mentry);
+			return ui_claimed;
+		}
+		break;
+	case POS_UPDATE:
+		if (inside && !mentry->inside) {
+			ui_menu_entry_enter(mentry, pos);
+			return ui_claimed;
+		} else if (!inside && mentry->inside) {
+			ui_menu_entry_leave(mentry, pos);
+		}
+		break;
+	}
+
+	return ui_unclaimed;
+}
+
+/** Get menu entry geometry.
+ *
+ * @param mentry Menu entry
+ * @param spos Entry position
+ * @param geom Structure to fill in with computed geometry
+ */
+void ui_menu_entry_get_geom(ui_menu_entry_t *mentry, gfx_coord2_t *pos,
+    ui_menu_entry_geom_t *geom)
+{
+	ui_resource_t *res;
+	gfx_coord_t hpad;
+	gfx_coord_t vpad;
+	gfx_coord_t width;
+
+	res = ui_menu_get_res(mentry->menu);
+
+	if (res->textmode) {
+		hpad = menu_entry_hpad_text;
+		vpad = menu_entry_vpad_text;
+	} else {
+		hpad = menu_entry_hpad;
+		vpad = menu_entry_vpad;
+	}
+
+	/* Compute total width of menu entry */
+	width = ui_menu_entry_calc_width(mentry->menu,
+	    mentry->menu->max_caption_w, mentry->menu->max_shortcut_w);
+
+	geom->outer_rect.p0 = *pos;
+	geom->outer_rect.p1.x = geom->outer_rect.p0.x + width;
+	geom->outer_rect.p1.y = geom->outer_rect.p0.y +
+	    ui_menu_entry_height(mentry);
+
+	geom->caption_pos.x = pos->x + hpad;
+	geom->caption_pos.y = pos->y + vpad;
+
+	geom->shortcut_pos.x = geom->outer_rect.p1.x - hpad;
+	geom->shortcut_pos.y = pos->y + vpad;
+}
+
+/** @}
+ */
Index: uspace/lib/ui/src/msgdialog.c
===================================================================
--- uspace/lib/ui/src/msgdialog.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/src/msgdialog.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,259 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Message dialog
+ */
+
+#include <errno.h>
+#include <mem.h>
+#include <stdlib.h>
+#include <ui/fixed.h>
+#include <ui/label.h>
+#include <ui/msgdialog.h>
+#include <ui/pbutton.h>
+#include <ui/resource.h>
+#include <ui/ui.h>
+#include <ui/window.h>
+#include "../private/msgdialog.h"
+
+static void ui_msg_dialog_wnd_close(ui_window_t *, void *);
+
+ui_window_cb_t ui_msg_dialog_wnd_cb = {
+	.close = ui_msg_dialog_wnd_close
+};
+
+static void ui_msg_dialog_btn_clicked(ui_pbutton_t *, void *);
+
+ui_pbutton_cb_t ui_msg_dialog_btn_cb = {
+	.clicked = ui_msg_dialog_btn_clicked
+};
+
+/** Initialize message dialog parameters structure.
+ *
+ * Message dialog parameters structure must always be initialized using
+ * this function first.
+ *
+ * @param params Message dialog parameters structure
+ */
+void ui_msg_dialog_params_init(ui_msg_dialog_params_t *params)
+{
+	memset(params, 0, sizeof(ui_msg_dialog_params_t));
+}
+
+/** Create new message dialog.
+ *
+ * @param ui User interface
+ * @param params Message dialog parameters
+ * @param rdialog Place to store pointer to new dialog
+ * @return EOK on success or an error code
+ */
+errno_t ui_msg_dialog_create(ui_t *ui, ui_msg_dialog_params_t *params,
+    ui_msg_dialog_t **rdialog)
+{
+	errno_t rc;
+	ui_msg_dialog_t *dialog;
+	ui_window_t *window = NULL;
+	ui_wnd_params_t wparams;
+	ui_fixed_t *fixed = NULL;
+	ui_label_t *label = NULL;
+	ui_pbutton_t *bok = NULL;
+	gfx_rect_t rect;
+	ui_resource_t *ui_res;
+
+	dialog = calloc(1, sizeof(ui_msg_dialog_t));
+	if (dialog == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	ui_wnd_params_init(&wparams);
+	wparams.caption = params->caption;
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		wparams.rect.p0.x = 0;
+		wparams.rect.p0.y = 0;
+		wparams.rect.p1.x = 20;
+		wparams.rect.p1.y = 7;
+	} else {
+		wparams.rect.p0.x = 0;
+		wparams.rect.p0.y = 0;
+		wparams.rect.p1.x = 200;
+		wparams.rect.p1.y = 110;
+	}
+
+	rc = ui_window_create(ui, &wparams, &window);
+	if (rc != EOK)
+		goto error;
+
+	ui_window_set_cb(window, &ui_msg_dialog_wnd_cb, dialog);
+
+	ui_res = ui_window_get_res(window);
+
+	rc = ui_fixed_create(&fixed);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_label_create(ui_res, params->text, &label);
+	if (rc != EOK)
+		goto error;
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 3;
+		rect.p0.y = 2;
+		rect.p1.x = 17;
+		rect.p1.y = 3;
+	} else {
+		rect.p0.x = 10;
+		rect.p0.y = 35;
+		rect.p1.x = 190;
+		rect.p1.y = 50;
+	}
+
+	ui_label_set_rect(label, &rect);
+	ui_label_set_halign(label, gfx_halign_center);
+
+	rc = ui_fixed_add(fixed, ui_label_ctl(label));
+	if (rc != EOK)
+		goto error;
+
+	label = NULL;
+
+	rc = ui_pbutton_create(ui_res, "OK", &bok);
+	if (rc != EOK)
+		goto error;
+
+	ui_pbutton_set_cb(bok, &ui_msg_dialog_btn_cb, dialog);
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 8;
+		rect.p0.y = 4;
+		rect.p1.x = 12;
+		rect.p1.y = 5;
+	} else {
+		rect.p0.x = 55;
+		rect.p0.y = 60;
+		rect.p1.x = 145;
+		rect.p1.y = 88;
+	}
+
+	ui_pbutton_set_rect(bok, &rect);
+
+	ui_pbutton_set_default(bok, true);
+
+	rc = ui_fixed_add(fixed, ui_pbutton_ctl(bok));
+	if (rc != EOK)
+		goto error;
+
+	dialog->bok = bok;
+	bok = NULL;
+
+	ui_window_add(window, ui_fixed_ctl(fixed));
+	fixed = NULL;
+
+	rc = ui_window_paint(window);
+	if (rc != EOK)
+		goto error;
+
+	dialog->window = window;
+	*rdialog = dialog;
+	return EOK;
+error:
+	if (bok != NULL)
+		ui_pbutton_destroy(bok);
+	if (label != NULL)
+		ui_label_destroy(label);
+	if (fixed != NULL)
+		ui_fixed_destroy(fixed);
+	if (window != NULL)
+		ui_window_destroy(window);
+	if (dialog != NULL)
+		free(dialog);
+	return rc;
+}
+
+/** Destroy message dialog.
+ *
+ * @param dialog Message dialog or @c NULL
+ */
+void ui_msg_dialog_destroy(ui_msg_dialog_t *dialog)
+{
+	if (dialog == NULL)
+		return;
+
+	ui_window_destroy(dialog->window);
+	free(dialog);
+}
+
+/** Set mesage dialog callback.
+ *
+ * @param dialog Message dialog
+ * @param cb Message dialog callbacks
+ * @param arg Callback argument
+ */
+void ui_msg_dialog_set_cb(ui_msg_dialog_t *dialog, ui_msg_dialog_cb_t *cb,
+    void *arg)
+{
+	dialog->cb = cb;
+	dialog->arg = arg;
+}
+
+/** Message dialog window close handler.
+ *
+ * @param window Window
+ * @param arg Argument (ui_msg_dialog_t *)
+ */
+static void ui_msg_dialog_wnd_close(ui_window_t *window, void *arg)
+{
+	ui_msg_dialog_t *dialog = (ui_msg_dialog_t *) arg;
+
+	if (dialog->cb != NULL && dialog->cb->close != NULL)
+		dialog->cb->close(dialog, dialog->arg);
+}
+
+/** Message dialog button click handler.
+ *
+ * @param pbutton Push button
+ * @param arg Argument (ui_msg_dialog_t *)
+ */
+static void ui_msg_dialog_btn_clicked(ui_pbutton_t *pbutton, void *arg)
+{
+	ui_msg_dialog_t *dialog = (ui_msg_dialog_t *) arg;
+
+	if (dialog->cb != NULL && dialog->cb->button != NULL)
+		dialog->cb->button(dialog, dialog->arg, 0);
+}
+
+/** @}
+ */
Index: uspace/lib/ui/src/paint.c
===================================================================
--- uspace/lib/ui/src/paint.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/src/paint.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,4 +39,5 @@
 #include <gfx/render.h>
 #include <ui/paint.h>
+#include "../private/resource.h"
 
 /** Paint bevel.
@@ -48,5 +49,5 @@
  * @param thickness Bevel thickness in pixels
  * @param inside Place to store rectangle of the interior or @c NULL
- * @reutrn EOK on success or an error code
+ * @return EOK on success or an error code
  */
 errno_t ui_paint_bevel(gfx_context_t *gc, gfx_rect_t *rect,
@@ -106,10 +107,6 @@
 	}
 
-	if (inside != NULL) {
-		inside->p0.x = rect->p0.x + thickness;
-		inside->p0.y = rect->p0.y + thickness;
-		inside->p1.x = rect->p1.x - thickness;
-		inside->p1.y = rect->p1.y - thickness;
-	}
+	if (inside != NULL)
+		ui_paint_get_bevel_inside(gc, rect, thickness, inside);
 
 	return EOK;
@@ -118,4 +115,213 @@
 }
 
+/** Get bevel interior rectangle.
+ *
+ * Get the bevel interior rectangle without painting it.
+ *
+ * @param gc Graphic context
+ * @param rect Rectangle to paint into
+ * @param thickness Bevel thickness in pixels
+ * @param inside Place to store rectangle of the interior
+ */
+void ui_paint_get_bevel_inside(gfx_context_t *gc, gfx_rect_t *rect,
+    gfx_coord_t thickness, gfx_rect_t *inside)
+{
+	inside->p0.x = rect->p0.x + thickness;
+	inside->p0.y = rect->p0.y + thickness;
+	inside->p1.x = rect->p1.x - thickness;
+	inside->p1.y = rect->p1.y - thickness;
+}
+
+/** Paint inset frame.
+ *
+ * @param resource UI resource
+ * @param rect Rectangle to paint onto
+ * @param inside Place to store inside rectangle or @c NULL
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_inset_frame(ui_resource_t *resource, gfx_rect_t *rect,
+    gfx_rect_t *inside)
+{
+	gfx_rect_t frame;
+	errno_t rc;
+
+	rc = ui_paint_bevel(resource->gc, rect,
+	    resource->wnd_shadow_color, resource->wnd_highlight_color,
+	    1, &frame);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_paint_bevel(resource->gc, &frame,
+	    resource->wnd_frame_sh_color, resource->wnd_frame_hi_color,
+	    1, inside);
+	if (rc != EOK)
+		goto error;
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Get inset frame interior rectangle.
+ *
+ * This allows one to get the interior rectangle without actually painting
+ * the inset frame.
+ *
+ * @param resource UI resource
+ * @param rect Rectangle to paint onto
+ * @param inside Place to store inside rectangle or @c NULL
+ */
+void ui_paint_get_inset_frame_inside(ui_resource_t *resource, gfx_rect_t *rect,
+    gfx_rect_t *inside)
+{
+	ui_paint_get_bevel_inside(resource->gc, rect, 2, inside);
+}
+
+/** Paint outset frame.
+ *
+ * @param resource UI resource
+ * @param rect Rectangle to paint onto
+ * @param inside Place to store inside rectangle or @c NULL
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_outset_frame(ui_resource_t *resource, gfx_rect_t *rect,
+    gfx_rect_t *inside)
+{
+	gfx_rect_t frame;
+	errno_t rc;
+
+	rc = ui_paint_bevel(resource->gc, rect,
+	    resource->wnd_frame_hi_color, resource->wnd_frame_sh_color,
+	    1, &frame);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_paint_bevel(resource->gc, &frame,
+	    resource->wnd_highlight_color, resource->wnd_shadow_color,
+	    1, inside);
+	if (rc != EOK)
+		goto error;
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Paint filled circle vertical scanline.
+ *
+ * @param gc Graphic context
+ * @param center Coordinates of the center of the circle
+ * @param x X-coordinate of the scanline
+ * @param y0 Lowest Y coordinate of the scanline (inclusive)
+ * @param y1 Highest Y coordinate of the scanline (inclusive)
+ * @param part Which part(s) of cicle to paint
+ * @return EOK on success or an error code
+ */
+static errno_t ui_paint_fcircle_line(gfx_context_t *gc, gfx_coord2_t *center,
+    gfx_coord_t x, gfx_coord_t y0, gfx_coord_t y1, ui_fcircle_part_t part)
+{
+	gfx_rect_t rect;
+	gfx_rect_t trect;
+
+	rect.p0.x = x;
+	rect.p0.y = y0;
+	rect.p1.x = x + 1;
+	rect.p1.y = y1;
+
+	/* Clip to upper-left/lower-right half of circle, if required */
+
+	if ((part & ui_fcircle_upleft) == 0) {
+		if (rect.p0.y < -rect.p1.x)
+			rect.p0.y = -rect.p1.x;
+	}
+
+	if ((part & ui_fcircle_lowright) == 0) {
+		if (rect.p1.y > -rect.p1.x)
+			rect.p1.y = -rect.p1.x;
+	}
+
+	/* If coordinates are reversed, there is nothing to do */
+	if (rect.p1.y <= rect.p0.y)
+		return EOK;
+
+	gfx_rect_translate(center, &rect, &trect);
+
+	return gfx_fill_rect(gc, &trect);
+}
+
+/** Paint filled circle scanlines corresponding to octant point.
+ *
+ * Fills the four vertical scanlines lying between the eight reflections
+ * of a circle point.
+ *
+ * @param gc Graphic context
+ * @param center Coordinates of the center
+ * @param r Radius in pixels
+ * @param part Which part(s) of cicle to paint
+ * @return EOK on success or an error code
+ */
+static int ui_paint_fcircle_point(gfx_context_t *gc, gfx_coord2_t *center,
+    gfx_coord2_t *p, ui_fcircle_part_t part)
+{
+	errno_t rc;
+
+	rc = ui_paint_fcircle_line(gc, center, +p->x, -p->y, p->y + 1, part);
+	if (rc != EOK)
+		return rc;
+	rc = ui_paint_fcircle_line(gc, center, -p->x, -p->y, p->y + 1, part);
+	if (rc != EOK)
+		return rc;
+	rc = ui_paint_fcircle_line(gc, center, +p->y, -p->x, p->x + 1, part);
+	if (rc != EOK)
+		return rc;
+	rc = ui_paint_fcircle_line(gc, center, -p->y, -p->x, p->x + 1, part);
+	if (rc != EOK)
+		return rc;
+
+	return EOK;
+}
+
+/** Paint a filled circle.
+ *
+ * @param gc Graphic context
+ * @param center Coordinates of the center
+ * @param r Radius in pixels
+ * @param part Which part(s) of cicle to paint
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_filled_circle(gfx_context_t *gc, gfx_coord2_t *center,
+    gfx_coord_t r, ui_fcircle_part_t part)
+{
+	gfx_coord2_t p;
+	gfx_coord_t f;
+	errno_t rc;
+
+	/* Run through one octant using circle midpoint algorithm */
+
+	p.x = r;
+	p.y = 0;
+	f = 1 - r;
+
+	rc = ui_paint_fcircle_point(gc, center, &p, part);
+	if (rc != EOK)
+		return rc;
+
+	while (p.x > p.y) {
+		if (f < 0) {
+			f = f + 2 * p.y + 3;
+		} else {
+			f = f + 2 * (p.y - p.x) + 5;
+			--p.x;
+		}
+		++p.y;
+
+		rc = ui_paint_fcircle_point(gc, center, &p, part);
+		if (rc != EOK)
+			return rc;
+	}
+
+	return EOK;
+}
+
 /** @}
  */
Index: uspace/lib/ui/src/pbutton.c
===================================================================
--- uspace/lib/ui/src/pbutton.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/src/pbutton.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -239,10 +239,38 @@
 }
 
-/** Paint push button.
- *
- * @param pbutton Push button
- * @return EOK on success or an error code
- */
-errno_t ui_pbutton_paint(ui_pbutton_t *pbutton)
+/** Paint button text shadow.
+ *
+ * @param pbutton Push button
+ * @return EOK on success or an error code
+ */
+static errno_t ui_pbutton_paint_text_shadow(ui_pbutton_t *pbutton)
+{
+	gfx_rect_t rect;
+	errno_t rc;
+
+	rect.p0.x = pbutton->rect.p0.x + 1;
+	rect.p0.y = pbutton->rect.p0.y + 1;
+	rect.p1.x = pbutton->rect.p1.x;
+	rect.p1.y = pbutton->rect.p1.y;
+
+	rc = gfx_set_color(pbutton->res->gc, pbutton->res->btn_shadow_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_fill_rect(pbutton->res->gc, &rect);
+	if (rc != EOK)
+		goto error;
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Paint push button in graphic mode.
+ *
+ * @param pbutton Push button
+ * @return EOK on success or an error code
+ */
+static errno_t ui_pbutton_paint_gfx(ui_pbutton_t *pbutton)
 {
 	gfx_coord2_t pos;
@@ -269,8 +297,4 @@
 		goto error;
 
-	rc = gfx_set_color(pbutton->res->gc, pbutton->res->btn_text_color);
-	if (rc != EOK)
-		goto error;
-
 	/* Center of button rectangle */
 	pos.x = (rect.p0.x + rect.p1.x) / 2;
@@ -283,4 +307,5 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.color = pbutton->res->btn_text_color;
 	fmt.halign = gfx_halign_center;
 	fmt.valign = gfx_valign_center;
@@ -304,7 +329,88 @@
 	}
 
+	rc = gfx_update(pbutton->res->gc);
+	if (rc != EOK)
+		goto error;
+
 	return EOK;
 error:
 	return rc;
+}
+
+/** Paint push button in text mode.
+ *
+ * @param pbutton Push button
+ * @return EOK on success or an error code
+ */
+static errno_t ui_pbutton_paint_text(ui_pbutton_t *pbutton)
+{
+	gfx_coord2_t pos;
+	gfx_text_fmt_t fmt;
+	gfx_rect_t rect;
+	bool depressed;
+	errno_t rc;
+
+	depressed = pbutton->held && pbutton->inside;
+
+	rc = gfx_set_color(pbutton->res->gc, pbutton->res->wnd_face_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_fill_rect(pbutton->res->gc, &pbutton->rect);
+	if (rc != EOK)
+		goto error;
+
+	rect.p0.x = pbutton->rect.p0.x + (depressed ? 1 : 0);
+	rect.p0.y = pbutton->rect.p0.y;
+	rect.p1.x = pbutton->rect.p1.x - 1 + (depressed ? 1 : 0);
+	rect.p1.y = pbutton->rect.p0.y + 1;
+
+	rc = gfx_set_color(pbutton->res->gc, pbutton->res->btn_highlight_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_fill_rect(pbutton->res->gc, &rect);
+	if (rc != EOK)
+		goto error;
+
+	/* Center of button rectangle */
+	pos.x = (rect.p0.x + rect.p1.x) / 2;
+	pos.y = (rect.p0.y + rect.p1.y) / 2;
+
+	gfx_text_fmt_init(&fmt);
+	fmt.color = pbutton->res->btn_text_color;
+	fmt.halign = gfx_halign_center;
+	fmt.valign = gfx_valign_center;
+
+	rc = gfx_puttext(pbutton->res->font, &pos, &fmt, pbutton->caption);
+	if (rc != EOK)
+		goto error;
+
+	if (!depressed) {
+		rc = ui_pbutton_paint_text_shadow(pbutton);
+		if (rc != EOK)
+			goto error;
+	}
+
+	rc = gfx_update(pbutton->res->gc);
+	if (rc != EOK)
+		goto error;
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Paint push button.
+ *
+ * @param pbutton Push button
+ * @return EOK on success or an error code
+ */
+errno_t ui_pbutton_paint(ui_pbutton_t *pbutton)
+{
+	if (pbutton->res->textmode)
+		return ui_pbutton_paint_text(pbutton);
+	else
+		return ui_pbutton_paint_gfx(pbutton);
 }
 
